
# API Rest Server

A Node API to creates CRUD routes and retreives random data from other APIs or from a configured metadata file.

## Requirements

* Docker

## Get Started

### Installing

Clone the project and enter on created directory:
`git clone git@bitbucket.org:zeedhi/api_rest_server.git && cd api_rest_server`

#### Docker

To install Docker, [click here](https://bitbucket.org/zeedhi/snippets/src/master/Dev/Docker/Workfolder/Server/php/sdk/).

##### Build and Run for Developer mode

To build and run a container with this project, just run the following command:
```
docker run -it --rm \
  --name <CONTAINER_NAME> \
  -w /app \
  -p <PORT>:3000 \
  -v <PATH_TO_API_REST_SERVER_DIR>:/app \
  --env HTTP_PROXY=<PROXY_CONFIG> \
  --env HTTPS_PROXY=<PROXY_CONFIG> \
  node:10.15.1-alpine \
  /bin/sh
```
>Remember to replace the variables inside <>. If you not using a proxy server, just remove the --env tags.

##### Build and Run for Production mode

To build a new image, just run the following command:

`docker build -t <IMAGE_NAME> .`

>If you are using a proxy server, do you need to configure http proxy variables o build your image: `docker build -t <IMAGE_NAME> . --build-arg HTTP_PROXY=<PROXY_CONFIG> --build-arg HTTPS_PROXY=<PROXY_CONFIG>`

To run a container with the builded image, just run the following command:

`docker run -d -p <PORT>:3000 <IMAGE_NAME>`

#### Postman

To test install [Postman](https://www.getpostman.com/apps) and import `api_rest_server.postman.json`

## Response Interfaces

### ErrorResponse : Object

Property | Type | Required | Description
-------- | ---- | -------- | -----------
`error` | Error | ✔ | The error object

### Error : Object

Property | Type | Required | Description
-------- | ---- | -------- | -----------
`status` | Number | ✔ | HTTP status code
`code` | String | ✔ | A human-readable code
`message` | String | ✔ | A human-readable message
`errorStack` | ErrorStack | | More specific information than the current object about the error (only development?)

### ErrorStack : Object

Property | Type | Required | Description
-------- | ---- | -------- | -----------
`code` | String | ✔ | A human-readable code.
`message` | String | ✔ | A human-readable message
`errorStack` | ErrorStack | | More specific information than the current object about the error

### Response : Object

Property | Type | Required | Description
-------- | ---- | -------- | -----------
`data` | Object or Array | ✔ | The requested data object or array
`pagination` | Pagination | | The pagination object

### Pagination : Object

Property | Type | Required | Description
-------- | ---- | -------- | -----------
`first` | String | ✔ | First page url
`last` | String | ✔ | Last page url
`prev` | String or null | | Previous page url
`next` | String or null | | Next page url
`limit` | Number | ✔ | Limit of items per page
