const orderTypes = {
  "asc": 1,
  "desc": -1,
  "same": 0
};

const compare = (obj, nextObj, orderByColumns, index, orderByTypes) => {
  if (obj[orderByColumns[index]] == nextObj[orderByColumns[index]]) {
    index++;
    if (orderByColumns.hasOwnProperty(index)) {
      return compare(obj, nextObj, orderByColumns, index, orderByTypes);
    } else {
      return orderTypes.same;
    }
  } else if (obj[orderByColumns[index]] > nextObj[orderByColumns[index]]) {
    if (orderByTypes.hasOwnProperty(index) && orderTypes.hasOwnProperty(orderByTypes[index])) {
      return orderTypes[orderByTypes[index]];
    } else {
      return orderTypes.asc;
    }
  } else if (obj[orderByColumns[index]] < nextObj[orderByColumns[index]]) {
    if (orderByTypes.hasOwnProperty(index) && orderTypes.hasOwnProperty(orderByTypes[index])) {
      return orderTypes[orderByTypes[index]] * -1;
    } else {
      return orderTypes.desc;
    }
  }
};

module.exports = {
  sortArray: (array, orderByColumns, orderByTypes = []) => {
    array.sort(function (obj, nextObj) {
      var index = 0;
      return compare(obj, nextObj, orderByColumns, index, orderByTypes);
    });
    return array;
  }
}
